module Hermes
  module Api
    module Dmo
      class PicturesController < Hermes::Api::Dmo::ApplicationController
        before_action :set_housing_offer
        before_action :set_picture, only: [:update, :destroy, :show]
        MAX_PICTURE_NUMBER = 20
        MUTATE_PARAMS = %i[]
        
        def mutate_params
          MUTATE_PARAMS
        end 
  
        def set_picture
          @picture = Hermes::Picture.find_by(id: params[:picture_id])
        end
        
        def set_housing_offer
          @housing_offer = Hermes::HousingOffer.find_by(id: params[:id])
        end
        
        def create
          user_id = @user.id
          @instance = Hermes::Picture.new(user_id: user_id, housing_offer_id: @housing_offer.id, readers:@housing_offer.readers, writers: @housing_offer.writers)
          if @housing_offer.ordered_picture_ids && @housing_offer.ordered_picture_ids.length >= MAX_PICTURE_NUMBER
            return render_json_error :unprocessable_entity, :number_of_pictures_exeded
          end
          if f = params[:file]
            blob = f.read
           @instance.set_blob(blob)
          else
            return render_json_error :unprocessable_entity, :no_file_in_the_request unless Rails.env == 'test'
          end
        return respond_with_errors(@instance) unless @instance.save
        render(jsonapi: @instance, serializer: Hermes::PictureSerializer, status: :created)
      end
      
      def destroy
        
        super
      end
        
        def update
          return render_json_error(:unprocessable_entity, :not_writers) unless @instance.reload && @instance.writable_by?(@user)
          if f = params[:file]
            blob = f.read
            @instance.set_blob(blob)
          else
            return render_json_error :unprocessable_entity, :no_file_in_the_request
          end
          return respond_with_errors(@instance) unless  @instance.save
          render(jsonapi: @instance, serializer: Hermes::PictureSerializer)
        end
    
    end
  end
end
end