# frozen_string_literal: true

# checker Api::Dmo::HermesController avant d'ajouter des méthodes
module Hermes
  module Api
    module Dmo
      class UpdateSubscriptionsController < Hermes::Api::Dmo::ApplicationController
            
        class << self
          def mutate_params
            {

            }
          end 
      
          def acceptable_params
            {
              name: {type: 'String'},
              object_id: {type: 'String'},
              email: {type: 'Boolean'},
              web: {type: 'Boolean'},
              slack: {type: 'Boolean'},
              sms: {type: 'Boolean'},
              user_email: {type: 'String'},
            }.merge(self.mutate_params).merge(super)
          end 
      
          def valid_operators
            %w[$in $nin $ne $gt $gte $lt $lte $regex]
          end
      
          def regex_params
            {

            }
          end 
        end


        def is_admin
          !(current_user_roles & ['Administrator', 'superadministrateur']).empty?
        end 

        def index
          acceptable_params *self.class.acceptable_params.keys
          valid_operators *self.class.valid_operators

          aggregation = index_aggregation(no_acl: true).where(reference_model_name: 'User')
          aggregation = aggregation.where(object_id: current_user.id) unless is_admin

          paginate(
            aggregation,
            each_serializer: @serializer,
            **@options
          )
        end
        
      end
    end
  end

end
