# frozen_string_literal: true

Rswag::Ui::Middleware.class_eval do
  def call(env)
    return [ 404, { 'Content-Type' => 'text/html' }, [ ] ] if HERMES_CONFIG['environment'] == 'PROD'
    if base_path?(env) 
      redirect_uri = env['SCRIPT_NAME'].chomp('/') + '/index.html'
      return [ 301, { 'Location' => redirect_uri }, [ ] ]
    end

    if index_path?(env)
      return [ 200, { 'Content-Type' => 'text/html' }, [ render_template ] ]
    end

    super
  end

end
