# frozen_string_literal: true

module Mongo
  class Collection::View::Aggregation
    def pluck *arr
      arr = arr.collect(&:to_s)
      if (i = arr.index('id'))
        arr[i] = '_id'
      end
      map do |elt|
        values = arr.map do |field|
          field.split('.').inject(elt) { |hash, key| hash[key] }
        end

        if values.length == 1
          values.first
        elsif values.length <= 0
          nil
        else
          values
        end
      end
    end
  end
end
