
require 'csv'

raise 'You need to load this script througth a require' unless __FILE__
# Replace following variables if need
FILE_TYPE = 'csv'
FILE_PATH = "."
END_OF_LIFE_STATUSES = [
  "LOGEMENT PLACE",
  "RETIRE PAR LE BAILLEUR",
  "RENDU AU BAILLEUR",
  "RETIRE PAR ALS",
  "ARCHIVE",
]
def run_script(skip)
  start_time = Time.now
  formated_t = start_time.strftime('%d-%m-%Y-%H:%M')
  puts "Start script at #{start_time}"
  file_name   = "#{HERMES_CONFIG['environment']}-#{formated_t}-#{__FILE__.split('/').last.gsub('.rb', ".#{FILE_TYPE}")}"
  file_class  = FILE_TYPE == 'csv' ? CSV : File
  file        = file_class.open("#{FILE_PATH}/#{file_name}", 'ab')
  ##############################################################################
  ##################################__SCRIPT__##################################
  # write the content of the script bellow
  file << [
    "housing_offer_id",
    "als_id",
    "external_ref",
    "lessor_contact_name",
    "lessor_email",
    "lessor_phone_number",
    "lessor_id",
    "offer_status",
    "lessor_status"
  ]
 
  offers = Hermes::HousingOffer.where({lessor_email: nil,}).nin(lessor_status: END_OF_LIFE_STATUSES)
  count = offers.count

  puts("#{count} offers with {lessor_email: nil, published: true } found")
  offers.batch_size(5).each_with_index do |offer, i|
    begin
      puts "#{i+1}/#{count}"
      line = [
        offer.id.to_s,
        offer.als_id&.to_s,
        offer.external_ref,
        offer.lessor_contact_name,
        offer.lessor_email,
        offer.lessor_phone_number,
        offer.lessor_id&.to_s,
        offer.offer_status,
        offer.lessor_status
      ]
      file << line
      puts line.join(', ')

    rescue Exception => e
      line = ["Erreur de traitement : #{e}"]
      file << [line]
      puts line.join(', ')
    end
  end 
  ##############################################################################
  ##############################################################################
  file.close
  stop_time = Time.now
  puts "Start end at #{stop_time}"
  puts "Executed in #{(stop_time - start_time).seconds}"
end

run_script( 0)