require 'rails_helper'
require [Hermes::Engine.root, %w[lib hermes tools specs]].flatten.join('/')

RSpec.describe ExecuteFlux5TaskJob do
  subject { ExecuteFlux5TaskJob }
 
  let!(:offer) { create(:housing_offer)}

  it 'error' do
    Hermes::LogJob.perform_now
    expect(Log.where(code: 'FLUX_5_ERROR_OFFER_NOT_FOUND').count).to eq(0)

    subject.perform_now(offer.id.to_s)
    Hermes::LogJob.perform_now
    expect(Log.where(code: 'FLUX_5_ERROR_OFFER_NOT_FOUND').count).to eq(0)

    expect { subject.perform_now("missing_id") }.to raise_error
    Hermes::LogJob.perform_now
    expect(Log.where(code: 'FLUX_5_ERROR_OFFER_NOT_FOUND').count).to eq(1)
  end
end
